/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: target_support.S 1824 2010-07-02 06:50:03Z mit-kimai $
 */

/*
 *	åȰ¸⥸塼 ֥APSH2A
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"


/*	CMCOR_0쥸ꤹ  */
#define CMCOR_0_VAL		((((PCLOCK / 8)/1000000) * 100)-1)

#if CMCOR_0_VAL > 0xffff
#error CMCOR_0 value > 0xffff(word data) !
#endif	/*	CMCOR_0_VAL > 0xffff  */

/*
 *	٥ΥåȰ¸ν
 *
 *	ȥåץ⥸塼ǡν˸ƤӽФ롥
 */

/*
 *	ROMˡDATAΥ0ȡBSSTXTľ֤
 *	뤿ᡤDATAΥ0ˤʤΥߡѿ
 *	ѥκŬˤΤɤᡢ֥ǵҤ
 *	Ƥ롣
 */
	.data
_dummy:
	.byte	0x00

	.text
	.align 2
	.global _hardware_init_hook
_hardware_init_hook:
	/*
	 *	åȯ(CPG)
	 *	I=160MHz,B=40MHz,P=40MHz
	 */
	mov.l _frqcr_addr, r1
	movi20 #0x1303, r2
	mov.w r2, @r1

	/* ϥ⡼ɤ */

		/*	sleep̿μ¹Ԥǡ꡼ץ⡼ɤ  */
	mov.l _stbcr_addr, r1
	mov   #0x00, r2
	mov.b r2, @r1

	/*
	 *	ƥ⥸塼Ÿ
	 *	Ѥ⥸塼ؤŸ򤳤ǹԤʤ
	 *	㤨СΡ100usecԤפԤưˤʤʤ
	 */
	mov   #(STBCR2_VALUE), r2
	mov.b r2, @((STBCR2 - STBCR), r1)

	mov.l _stbcr3_addr, r1
	mov   #(STBCR3_VALUE), r2
	mov.b r2, @r1

	mov   #(STBCR4_VALUE), r2
	mov.b r2, @((STBCR4 - STBCR3), r1)

	/*
	 *	RAMͭˤ
	 *
	 *	ƥॳȥ쥸ջ
	 *SYSCRnؤΥ饤̿ľ˥꡼֤̿롣
	 *¢RAMְʳ˥ץ֤롣
	 */
	mov.l _sys_cr1_addr, r1	 /*  ¢RAMؤΥͭ  */
	mov   #0xff, r0
	mov.b r0, @r1
	mov.b @r1, r3				/*	ߡ꡼  */
							/*	¢RAMؤΥ饤ͭ  */
	mov.b r0, @((SYSCR2 - SYSCR1), r1)	/*	r0=0xff  */
	mov.b @((SYSCR2 - SYSCR1), r1), r0	/*	ߡ꡼  */

	/* ХơȥȥBSCˤ */
	mov.l _bsc_base_addr, r1
	movi20 #0x00001010, r0
	mov.l r0, @((CMNCR - BSC_BASE),r1)
	movi20 #0x00004400, r0
	mov.l r0, @((CS3BCR - BSC_BASE),r1)
	movi20 #0x00002491, r0
	mov.l r0, @((CS3WCR - BSC_BASE),r1)
	movi20 #0x00000909, r0
	mov.l r0, @((SDCR - BSC_BASE),r1)
	mov.l _rtcsr_val, r0
	mov.l r0, @((RTCSR - BSC_BASE),r1)
	mov.l _rtcor_val, r0
	mov.l r0, @((RTCOR - BSC_BASE),r1)

	/* SDRAM ³ݡȤν */
	mov.l _pfc_base_addr, r1
	movi20 #0x1111, r0
	mov.w r0, @((PACRL4 - PFC_BASE),r1)
	mov.w r0, @((PACRL3 - PFC_BASE),r1)	/*	r0=0x1111  */
	mov.w r0, @((PACRL2 - PFC_BASE),r1)	/*	r0=0x1111  */
	movi20 #0x1110, r0
	mov.w r0, @((PACRL1 - PFC_BASE),r1)

	mov   #0x00, r0
	mov.w r0, @((PBIORH - PFC_BASE),r1)
	mov.w r0, @((PBIORL - PFC_BASE),r1)	/*	r0=0x0000  */
	mov   #0x10, r0
	mov.w r0, @((PBCRH1 - PFC_BASE),r1)
	mov   #0x11, r0
	mov.w r0, @((PBCRL3 - PFC_BASE),r1)
	movi20 #0x0111, r0
	mov.w r0, @((PBCRL2 - PFC_BASE),r1)
	movi20 #0x1010, r0
	mov.w r0, @((PBCRL1 - PFC_BASE),r1)

	mov   #0x00, r0
	mov.w r0, @((PDIOR - PFC_BASE),r1)
	movi20 #0x1111, r0
	mov.w r0, @((PDCRL4 - PFC_BASE),r1)
	mov.w r0, @((PDCRL3 - PFC_BASE),r1)	/*	r0=0x1111  */
	mov.w r0, @((PDCRL2 - PFC_BASE),r1)	/*	r0=0x1111  */
	mov.w r0, @((PDCRL1 - PFC_BASE),r1)	/*	r0=0x1111  */

	/*
	 *	100usecԤ
	 */
	mov.l _cmt_base_addr, r1		/*	ޥ	*/
	mov   #0, r0
	mov.w r0, @((CMSTR - CMT_BASE),r1)
									/*	å쥯ȡP/8  */
	mov.w r0, @((CMCSR_0 - CMT_BASE),r1)
									/*	󥿡ꥢ  */
	mov.w r0, @((CMCNT_0 - CMT_BASE),r1)
	movi20 #(CMCOR_0_VAL), r0		/*	ɸ	*/
	mov.w r0, @((CMCOR_0 - CMT_BASE),r1)
	mov   #1, r0					/*	ޥȳ	*/
	mov.w r0, @((CMSTR - CMT_BASE),r1)

	movi20 #(CMCSR_CMF), r2
1:
	mov.w @((CMCSR_0 - CMT_BASE),r1), r0
	tst   r2, r0				/*	ڥޥåե饰Ƚ	*/
	bt	  1b

	mov.l _sdram_mode_addr, r1	/*	RAMΥ⡼쥸  */
	mov   #0x00, r2

	rts
	 mov.w r2, @r1

	.align 4
_frqcr_addr:
	.long FRQCR

_sys_cr1_addr:
	.long SYSCR1

_stbcr_addr:
	.long STBCR
_stbcr3_addr:
	.long STBCR3

_bsc_base_addr:
	.long BSC_BASE
_rtcsr_val:
	.long 0xa55a0008
_rtcor_val:
	.long 0xa55a009c

_pfc_base_addr:
	.long PFC_BASE

_cmt_base_addr:
	.long CMT_BASE

_sdram_mode_addr:
	.long 0xfffc5040

